Package: org.codehaus.groovy.classgen.asm

## [Java] Class BinaryExpressionMultiTypeDispatcher

- org.codehaus.groovy.classgen.asm.BinaryExpressionMultiTypeDispatcher

- This class is for internal use only! This class will dispatch to the right type adapters according to the kind of binary expression that is provided.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected BinaryExpressionWriter[]` | `binExpWriter` |
    `static Map<ClassNode, Integer>` | `typeMap` |
    `static String[]` | `typeMapKeyNames` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `def` | `BinaryExpressionMultiTypeDispatcher(WriterController wc)`
    `` | `protected void` | `assignToArray(Expression orig, Expression receiver, Expression index, Expression rhsValueLoader)`
    `` | `protected boolean` | `doPrimitiveCompare(ClassNode leftType, ClassNode rightType, BinaryExpression binExp)`
    `` | `protected boolean` | `doPrimtiveCompare(ClassNode leftType, ClassNode rightType, BinaryExpression binExp)`
    `` | `protected void` | `evaluateBinaryExpression(String message, BinaryExpression binExp)`
    `` | `protected void` | `evaluateBinaryExpressionWithAssignment(String method, BinaryExpression binExp)`
    `` | `protected void` | `evaluateCompareExpression(MethodCaller compareMethod, BinaryExpression binExp)`
    `` | `protected int` | `getOperandType(ClassNode type)`
    `` | `protected BinaryExpressionWriter[]` | `initializeDelegateHelpers()`
    `` | `protected void` | `writePostOrPrefixMethod(int op, String method, Expression expression, Expression orig)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BinaryExpressionHelper` | `assignToArray, eval, evaluateArrayAssignmentWithOperator, evaluateBinaryExpression, evaluateBinaryExpressionWithAssignment, evaluateCompareExpression, evaluateEqual, evaluatePostfixMethod, evaluatePrefixMethod, evaluateTernary, getController, getIsCaseMethod, writePostOrPrefixMethod`
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected BinaryExpressionWriter[] binExpWriter

    - #### public static Map<ClassNode, Integer> typeMap

    - #### public static final String[] typeMapKeyNames

  - ### Method Detail

    - #### public def BinaryExpressionMultiTypeDispatcher(WriterController wc)

    - #### @Override protected void assignToArray(Expression orig, Expression receiver, Expression index, Expression rhsValueLoader)

    - #### protected boolean doPrimitiveCompare(ClassNode leftType, ClassNode rightType, BinaryExpression binExp)

    - #### @Deprecated protected boolean doPrimtiveCompare(ClassNode leftType, ClassNode rightType, BinaryExpression binExp)

    - #### @Override protected void evaluateBinaryExpression(String message, BinaryExpression binExp)

    - #### @Override protected void evaluateBinaryExpressionWithAssignment(String method, BinaryExpression binExp)

    - #### @Override protected void evaluateCompareExpression(MethodCaller compareMethod, BinaryExpression binExp)

    - #### protected int getOperandType(ClassNode type)

    - #### protected BinaryExpressionWriter[] initializeDelegateHelpers()

    - #### @Override protected void writePostOrPrefixMethod(int op, String method, Expression expression, Expression orig)